"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeModuleErrorHandlerRuntimeModule = void 0;
// runtime module class is generated dynamically based on the compiler instance
// this way it's compatible with both webpack and rspack
const makeModuleErrorHandlerRuntimeModule = (compiler, moduleConfig) => {
  const Template = compiler.webpack.Template;
  const RuntimeGlobals = compiler.webpack.RuntimeGlobals;
  const RuntimeModule = compiler.webpack.RuntimeModule;
  const ModuleErrorHandlerRuntimeModule = class extends RuntimeModule {
    constructor(config) {
      super('repack/module error handler', RuntimeModule.STAGE_BASIC);
      this.config = config;
    }
    generate() {
      return Template.asString([Template.getFunctionContent(require('./implementation/moduleErrorHandler.js')).replaceAll('$globalObject$', this.config.globalObject).replaceAll('$interceptModuleExecution$', RuntimeGlobals.interceptModuleExecution)]);
    }
  };
  return new ModuleErrorHandlerRuntimeModule(moduleConfig);
};
exports.makeModuleErrorHandlerRuntimeModule = makeModuleErrorHandlerRuntimeModule;
//# sourceMappingURL=ModuleErrorHandlerRuntimeModule.js.map